#ifndef LIST_
#define LIST_

#ifdef __cplusplus
  extern "C" {
#endif
  #include <stdlib.h>
  #include <string.h>
#ifdef __cplusplus
	     }
#endif

#include <iostream.h>

template<class T> class List {
    unsigned long n;
    unsigned long nmax;
    unsigned long ninc;
    T** data;
  public:
    List(unsigned long ni=10) {
      ninc=ni;
      nmax=ni;
      n=0;
      data=new T* [nmax];
      for (unsigned int i=0;i<nmax;i++)
	data[i]=(T*)NULL;
    }
    
    unsigned long Size() { return n; }
    
    void Clear(int del=0) { 
      if (del) {
	unsigned int i;

	for (i=0;i<n;i++)
	  if (data[i]!=NULL) 
	    free(data[i]);
      }
      delete data;
      nmax=ninc;
      data=new T* [nmax];
      for (unsigned int i=0;i<nmax;i++)
	data[i]=(T*)NULL;
      n=0;
    }
    
    void Add(T t) {
      if (n==nmax) {
	T** odata=data;
	nmax+=ninc;
	data=new T* [nmax];
	memcpy(data,odata,sizeof(T*)*n);
	delete odata;
      }
      data[n]=(T*)malloc(sizeof(T));
      memcpy(data[n],&t,sizeof(T));
      n++;
    }
    
    void Ins(T t,unsigned long i) {
      unsigned long j;
      
      if ((0<=i) && (i<=n)) {
	if (n==nmax) {
	  T** odata=data;
	  nmax+=ninc;
	  data=new T* [nmax];
	  memcpy(data,odata,sizeof(T*)*n);
	  delete odata;
	}
	for (j=n;j>i;j--)
	  data[j]=data[j-1];
	data[n]=(T*)malloc(sizeof(T));
	memcpy(data[n],&t,sizeof(T));
	n++;
      }
    }
    
    void Del(unsigned long i) {
      unsigned long j;
      
      if ((0<=i) && (i<n)) {
	free(data[i]);
	for (j=i;j<n-1;j++)
	  data[j]=data[j+1];
	n--;
      }
    }
    
    void Del(T t) {
      unsigned long i;
      i=Find(t);
      Del(i);
    }
    
    unsigned long Find(T t) {
      unsigned long i;
      
      for (i=0;i<n;i++)
	if (*(data[i])==t)
	  return i;
      return n+1;         /* n+1 if t not in list */
    }
    
    T Get(unsigned long i) {
      if ((0<=i) &&  (i<n)) {
	return *(data[i]);
      }
      return (T)0;
    }
    
    ~List() {
      delete data;
    }
};

#endif
