#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <ostream.h>
#include <string.h>
#include <sys/stat.h>

#if defined(_WIN32) || defined(_WIN64)
#else
  #include <unistd.h>
#endif

#include "cfgtools.h"

#define SSET(S,X) { \
  if (X!=NULL) { \
    S=new char [strlen(X)+1]; \
    strcpy(S,X); \
  } else { \
    S=new char [1]; \
    S[0]=0; \
  } \
}

#define ISET(S,X) { \
  if (X!=NULL) { \
    sscanf(X,"%d",&S); \
  } else { \
    S=80; \
  } \
}

static char *cfgfile=NULL;
static char *apppath=NULL;

void ParseCommandline(int argc,char* argv[]) {
  char *buffer;
  
  // determine application path
  buffer=new char [strlen(argv[0])+1];
  strcpy(buffer,argv[0]);
  int i=strlen(buffer)-1;
  #ifdef WINDOWS
    while ((i>0) && (buffer[i]!='\\')) i--;
  #else
    while ((i>0) && (buffer[i]!='/')) i--;
  #endif
  buffer[i]=0;
  if (strlen(buffer)==0) {
    #ifdef WINDOWS
      strcpy(buffer,".\\");
    #else
      strcpy(buffer,"./");
    #endif
  }
  Path(buffer);

  for (int i=1;i<argc;i++) {
    if (!strcmp(argv[i],"-c")) {
      cfg(argv[i+1]);
    }
  }

}

void Path(const char *p) {
  if (apppath!=NULL) delete apppath;
  apppath=new char [strlen(p)+2];
  strcpy(apppath,p);
  #ifdef WINDOWS
    if (apppath[strlen(p)-1]!='\\') 
      strcat(apppath,"\\");
  #else
    if (apppath[strlen(p)-1]!='/')
      strcat(apppath,"/");
  #endif
}

char *Path() {
  return apppath;
}

void cfg(const char *fname) {
  #ifdef WINDOWS
    if (Path()==NULL) Path(".\\");
  #else
    if (Path()==NULL) Path("./");
  #endif
  if (cfgfile!=NULL) delete cfgfile;
  cfgfile=new char [strlen(apppath)+strlen(fname)+1];
  sprintf(cfgfile,"%s%s",Path(),fname);
}

char *cfg() { return cfgfile; }

static int Readln(FILE *f,char *buffer,int bsize) {
  int result;
  int i=0;
  char c;
  
  do {
    result=fscanf(f,"%c",&c);
    if ((result!=EOF) && (c!='\n')) {
      buffer[i++]=c;
      buffer[i]=0;
    }
  } while ((result!=EOF) && (c!='\n') && (i<bsize));

  return result;
  
}

char* GetValue(FILE *f,const char *section,const char *arg) {
  int result;
  char buffer[2049];
  char earg[2049];
  char *value;
  
  rewind(f);

  //--- search section -----------------------------------------
  sprintf(earg,"[%s]",section);
  do {
    result=Readln(f,buffer,2048);
  } while ((result!=EOF) && (strstr(buffer,earg)!=buffer));
  if (strstr(buffer,earg)!=buffer) return NULL;

  //--- search entry ------------------------------------------
  sprintf(earg,"%s=",arg);
  do {
    result=Readln(f,buffer,2048);
  } while ((strncmp(buffer,earg,strlen(earg))) && (result!=EOF) && (buffer[0]!='['));

  if (!strncmp(buffer,earg,strlen(earg))) {
    value=strtok(buffer,"=");
    value=strtok(NULL,"=");  

    //--- need to take care on CR/LF !!!

    return value;
  }

  return NULL;
}

char* GetValue(const char *cfgname,const char *section,const char *arg) {
  FILE *cfg;
  char *rval;

  cfg=fopen(cfgname,"r");
  if (cfg==NULL) {
    printf("cfgtools.GetValue: Initialisierungsdatei '%s' nicht gefunden.\n",cfgname);
    return NULL;
  }

  rval=GetValue(cfg,section,arg);
  fclose(cfg);

  return rval;

}

char* GetValue(const char *section,const char *arg) {
  if (cfgfile!=NULL) return GetValue(cfgfile,section,arg);
  return NULL;
}

long int FILESIZE(const char *fname) {
  struct stat status;

  stat(fname,&status);
  return status.st_size;
}
