#ifndef MAUSDB_INTERFACE_
#define MAUSDB_INTERFACE_

#if defined(_WIN32) || defined(_WIN64)
  #include <windows.h>
#endif

#include <postgresql/libpq-fe.h>

#include "date.h"

class Database {
  PGconn *db;
  PGresult *result;
  int rowid;
  long numrows;
  int dbglevel;
 public:
  Database();
  int Connect(const char *host,const char *dbname,const char *uname,const char *passwd);
  int Disconnect();

  void DebugLevel(int l=0);
  // 0: no debugging
  // 1: only errors
  // 2: info
  // 3: sql trace

  int SQL(const char *sql);
  long NumRows();
  int NextRow();
  int NotNull(int rc=0);

  long int GetLong(int rc=0);
  unsigned long int GetUnsignedLong(int rc=0);
  unsigned int GetUInt(int rc=0);
  int GetInt(int rc=0);
  float GetFloat(int rc=0);
  double GetDouble(int rc=0);
  char GetChar(int rc=0);
  char *GetString(int rc=0);
  
  int Errno();
  char *Error();

  ~Database();
};

#endif
