#include <stdlib.h>
#include <stdio.h>
#include <time.h>

char ts[1024];

char *Time2ISO(time_t t) {  // returns GMT Time representation
  struct tm *tt;
  tzset();

  tt=gmtime(&t);

  static char ts[256];
  if (tt->tm_isdst>0) {  // daylightsaving active !!!
    time_t tz=t+3600;
    tt=gmtime(&tz);
    sprintf(ts,"%04d-%02d-%02d %02d:%02d:%02d+00",
	    tt->tm_year+1900,tt->tm_mon+1,tt->tm_mday,tt->tm_hour,tt->tm_min,tt->tm_sec);
    printf(" Daylightsaving on ");
  } else {
    sprintf(ts,"%04d-%02d-%02d %02d:%02d:%02d+00",
	    tt->tm_year+1900,tt->tm_mon+1,tt->tm_mday,tt->tm_hour,tt->tm_min,tt->tm_sec);
  }

  // should be GMT+TZOFFSET

  return ts;
}

int dst[][6]={
  {30,3,2008,26,10,2008},
  {29,3,2009,25,10,2009},
  {28,3,2010,31,10,2010},
  {27,3,2011,30,10,2011},
  {1,1,1970,30,10,2011},
  {0,0,0,0,0,0}
};

void Time2DT(time_t t,char *ts,int localtz) {
  struct tm *tt;
  tzset();
  tt=gmtime(&t);

  sprintf(ts,"%04d%02d%02dT%02d%02d%02dZ",
	  tt->tm_year+1900,tt->tm_mon+1,tt->tm_mday,tt->tm_hour,tt->tm_min,tt->tm_sec);
}

int main() {
  struct tm t;
  struct tm *t1;
  time_t tt;

  int i=0;
  char ts[256];

  tt=1206910338;
  Time2DT(tt,ts,0);
  printf("%ld : %s\n",tt,Time2ISO(tt),ts);

  do {
    t.tm_sec = 0;  t.tm_min = 0; t.tm_hour= 2+1;  // 2 + TZOFFSET (=1 for CET)
    t.tm_mday=dst[i][0]; t.tm_mon = 3-1;  t.tm_year=dst[i][2]-1900;
    tt=mktime(&t);

    printf("BEGIN DST %ld : %s ",tt,Time2ISO(tt));

    t.tm_sec = 0;  t.tm_min = 0; t.tm_hour= 3+1;  // 2 + TZOFFSET (=1 for CET)
    t.tm_mday=dst[i][3]; t.tm_mon = 10-1;  t.tm_year=dst[i][5]-1900;
    tt=mktime(&t);

    printf("  END DST %ld : %s\n",tt,Time2ISO(tt));

    i++;
  } while (dst[i][0]>0);
}
