#include <vCard.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define APPEND(buffer,X,V) \
if ((strlen(X)>0) || (strlen(V)>0)) { \
    char *app_b; \
    if (buffer) { \
      app_b=new char [strlen(buffer)+strlen(X)+strlen(V)+1+1]; \
      strcpy(app_b,buffer); \
      delete buffer; \
    } else { \
      app_b=new char [strlen(X)+strlen(V)+1+1]; \
      strcpy(app_b,""); \
    } \
    buffer=app_b; \
    strcat(buffer,X); \
    strcat(buffer,V); \
    strcat(buffer,"\n"); \
}

#define SAPPEND(buffer,X) \
if (strlen(X)>0) { \
  char *app_b; \
  if (buffer) { \
    app_b=new char [strlen(buffer)+strlen(X)+1+1]; \
    strcpy(app_b,buffer); \
    delete buffer; \
  } else { \
    app_b=new char [strlen(X)+1+1]; \
    strcpy(app_b,""); \
  } \
  buffer=app_b; \
  strcat(buffer,X); \
}

#define DTAPPEND(buffer,X,V) \
if (V>0) { \
   char ts[255]; \
   Time2DT(V,ts,0); \
   APPEND(buffer,X,ts) \
}

#define DTAPPENDNOTIME(buffer,X,V) \
if (V>0) { \
   char ts[255]; \
   Time2DT(V,ts,0,1); \
   APPEND(buffer,X,ts) \
}

vAddress::vAddress(char *text) {
  type=-1;
  strcpy(po_box,"");
  strcpy(street,"");
  strcpy(city,"");
  strcpy(state,"");
  strcpy(postal_code,"");
  strcpy(country,"");
}

void vAddress::Type(int x) {
  type=x;
}

int vAddress::Type() {
  return type;
}

void vAddress::Street(const char* x) {
  strcpy(street,x);
}

const char* vAddress::Street() {
  return street;
}

void vAddress::City(const char* x) {
  strcpy(city,x);
}

const char* vAddress::City() {
  return city;
}

void vAddress::State(const char* x) {
  strcpy(state,x);
}

const char* vAddress::State() {
  return state;
}

void vAddress::ZIP(const char* x) {
  strcpy(postal_code,x);
}

const char* vAddress::ZIP() {
  return postal_code;
}

void vAddress::Country(const char* x) {
  strcpy(country,x);
}

const char* vAddress::Country() {
  return country;
}

void vAddress::Write(char **buffer) {
  char s[4096];

  // ADR;TYPE=home:PSF;;Heynahtsstrae 8;Dresden;Sachsen;01309;Germany
  sprintf(s,"%s;;%s;%s;%s;%s,%s",po_box,street,city,state,postal_code,country);
  
  switch (type) {
    case 1: APPEND(*buffer,"ADR;TYPE=home:",s); break;
    case 2: APPEND(*buffer,"ADR;TYPE=work:",s); break;
    default: APPEND(*buffer,"ADR;TYPE=home:",s);
  }
}

//------------------------------------------------------------------------------------------
// int type; // 1 = TEL;TYPE=HOME | 3 = TEL;TYPE=CELL | 4 = EMAIL | 5 = URL | 10 = TEL;TYPE=WORK | 11 = TEL;TYPE=FAX

vCommData::vCommData(char *text) {
  type=0;
  strcpy(value,"");
}

void vCommData::Type(int x) {
  type=x;
}

int vCommData::Type() {
  return type;
}

void vCommData::Value(char* x) {
  strcpy(value,x);
}

char* vCommData::Value() {
  return value;
}

void vCommData::Write(char **buffer) {
  switch (type) {
    case  1:  APPEND(*buffer,"TEL;TYPE=HOME:",value) break;
    case  3:  APPEND(*buffer,"TEL;TYPE=CELL:",value) break;
    case  4:  APPEND(*buffer,"EMAIL:",value) break;
    case  5:  APPEND(*buffer,"URL:",value) break;
    case 10:  APPEND(*buffer,"TEL;TYPE=WORK:",value) break;
    case 11:  APPEND(*buffer,"TEL;TYPE=FAX:",value) break;   // ;TYPE=WORK ??
    default: APPEND(*buffer,"TEL;TYPE=HOME:",value);
  }
}

//------------------------------------------------------------------------------------------

vCard::vCard(char *text) {
  id=0;
  last_update=0;
  strcpy(suid,"");
  photo_type=0;
  importance=0;
  sensitivity=0;
  strcpy(subject,"");
  strcpy(folder,"");
  strcpy(anniversary,"");
  strcpy(first_name,"");
  strcpy(middle_name,"");
  strcpy(last_name,"");
  strcpy(display_name,"");
  strcpy(birthday,"");
  strcpy(body,"");
  strcpy(categories,"");
  strcpy(children,"");
  strcpy(hobbies,"");
  strcpy(initials,"");
  strcpy(languages,"");
  strcpy(nickname,"");
  strcpy(spouse,"");
  strcpy(suffix,"");
  strcpy(title,"");
  strcpy(gender,"");
  strcpy(assistant,"");
  strcpy(company,"");
  strcpy(department,"");
  strcpy(job_title,"");
  strcpy(manager,"");
  strcpy(mileage,"");
  strcpy(office_location,"");
  strcpy(profession,"");
  strcpy(companies,"");
  
  n_address=0;
  address=NULL;
  
  n_commdata=0;
  commdata=NULL;
}

vCard::~vCard() {
  if (n_address>0) {
    for (int i=0;i<n_address;i++) delete address[i];
    delete address;
  }
  if (n_commdata>0) {
    for (int i=0;i<n_commdata;i++) delete commdata[i];
    delete commdata;
  }
}

void vCard::ID(unsigned long x) {
  id=x;
}

unsigned long vCard::ID() {
  return id;
}

void vCard::LastUpdate(time_t x) {
  last_update=x;
}

time_t vCard::LastUpdate() {
  return last_update;
}

void vCard::UID(const char* x) {
  strcpy(suid,x);
}

const char* vCard::UID() {
  return suid;
}

void vCard::PhotoType(int x) {
  photo_type=x;
}

int vCard::PhotoType() {
  return photo_type;
}

void vCard::Importance(int x) {
  importance=x;
}

int vCard::Importance() {
  return importance;
}

void vCard::Sensitivity(int x) {
  sensitivity=x;
}

int vCard::Sensitivity() {
  return sensitivity;
}

void vCard::Subject(const char* x) {
  if (!strcmp(x,"")) {
    sprintf(subject,"%s, %s",last_name,first_name);
  } else
    strcpy(subject,x);
}

const char* vCard::Subject() {
  return subject;
}

void vCard::Folder(const char* x) {
  strcpy(folder,x);
}

const char* vCard::Folder() {
  return folder;
}

void vCard::Firstname(const char* x) {
  strcpy(first_name,x);
}

const char* vCard::Firstname() {
  return first_name;
}

void vCard::Middlename(const char* x) {
  strcpy(middle_name,x);
}

const char* vCard::Middlename() {
  return middle_name;
}

void vCard::Surename(const char* x) {
  strcpy(last_name,x);
}

const char* vCard::Surename() {
  return last_name;
}

void vCard::Displayname(const char* x) {
  strcpy(display_name,x);
}

const char* vCard::Displayname() {
  return display_name;
}

void vCard::Birthday(const char* x) {
  strcpy(birthday,x);
}

const char* vCard::Birthday() {
  return birthday;
}

void vCard::Anniversary(const char* x) {
  strcpy(anniversary,x);
}

const char* vCard::Anniversary() {
  return anniversary;
}

void vCard::Note(const char* x) {
  strcpy(body,x);
}

const char* vCard::Note() {
  return body;
}

void vCard::Category(const char* x) {
  strcpy(categories,x);
}

const char* vCard::Category() {
  return categories;
}

void vCard::Children(const char* x) {
  strcpy(children,x);
}

const char* vCard::Children() {
  return children;
}

void vCard::Hobby(const char* x) {
  strcpy(hobbies,x);
}

const char* vCard::Hobby() {
  return hobbies;
}

void vCard::Initials(const char* x) {
  strcpy(initials,x);
}

const char* vCard::Initials() {
  return initials;
}

void vCard::Language(const char* x) {
  strcpy(languages,x);
}

const char* vCard::Language() {
  return languages;
}

void vCard::Nickname(const char* x) {
  strcpy(nickname,x);
}

const char* vCard::Nickname() {
  return nickname;
}

void vCard::Spouse(const char* x) {
  strcpy(spouse,x);
}

const char* vCard::Spouse() {
  return spouse;
}

void vCard::Suffix(const char* x) {
  strcpy(suffix,x);
}

const char* vCard::Suffix() {
  return suffix;
}

void vCard::Title(const char* x) {
  strcpy(title,x);
}

const char* vCard::Title() {
  return title;
}

void vCard::Gender(const char* x) {
  strcpy(gender,x);
}

const char* vCard::Gender() {
  return gender;
}

void vCard::Assistant(const char* x) {
  strcpy(assistant,x);
}

const char* vCard::Assistant() {
  return assistant;
}

void vCard::Company(const char* x) {
  strcpy(company,x);
}

const char* vCard::Company() {
  return company;
}

void vCard::Department(const char* x) {
  strcpy(department,x);
}

const char* vCard::Department() {
  return department;
}

void vCard::JobTitle(const char* x) {
  strcpy(job_title,x);
}

const char* vCard::JobTitle() {
  return job_title;
}

void vCard::Manager(const char* x) {
  strcpy(manager,x);
}

const char* vCard::Manager() {
  return manager;
}

void vCard::Mileage(const char* x) {
  strcpy(mileage,x);
}

const char* vCard::Mileage() {
  return mileage;
}

void vCard::OfficeLocation(const char* x) {
  strcpy(office_location,x);
}

const char* vCard::OfficeLocation() {
  return office_location;
}

void vCard::Profession(const char* x) {
  strcpy(profession,x);
}

const char* vCard::Profession() {
  return profession;
}

void vCard::Companies(const char* x) {
  strcpy(companies,x);
}

const char* vCard::Companies() {
  return companies;
}

void vCard::AddAddress(vAddress *p) {
  if (address) {
    vAddress **n=new vAddress* [n_address+1];
    for (int i=0;i<n_address;i++) n[i]=address[i];
    delete address;
    address=n;
  } else
    address=new vAddress* [1];

  address[n_address]=p;
  n_address++;
}

int vCard::NAddress() {
  return n_address;
}

vAddress* vCard::Address(int i) {
  if ((address) && (0<=i) && (i<n_address)) return address[i];

  return NULL;
}

void vCard::AddCommData(vCommData *p) {
  if (commdata) {
    vCommData **n=new vCommData* [n_commdata+1];
    for (int i=0;i<n_commdata;i++) n[i]=commdata[i];
    delete commdata;
    commdata=n;
  } else
    commdata=new vCommData* [1];

  commdata[n_commdata]=p;
  n_commdata++;
}

int vCard::NCommData() {
  return n_commdata;
}

vCommData* vCard::CommData(int i) {
  if ((commdata) && (0<=i) && (i<n_commdata)) return commdata[i];

  return NULL;
}

void vCard::Write(char **buffer) {
  char s[4096];

  APPEND(*buffer,"BEGIN:","VCARD");
  APPEND(*buffer,"VERSION:","2.1");
  APPEND(*buffer,"CLASS:","PUBLIC");
  // APPEND(*buffer,"CATEGORIES","Family");
  APPEND(*buffer,"UID:",suid);
  APPEND(*buffer,"FN:",display_name);
  sprintf(s,"%s;%s;%s;%s;%s",last_name,first_name,middle_name,"",title);
  APPEND(*buffer,"N:",s);
  APPEND(*buffer,"NICKNAME:",nickname);
  APPEND(*buffer,"ORG:",company);
  // APPEND(*buffer,"ROLE:","wiss. Mitarbeiter");
  APPEND(*buffer,"TITLE:",job_title);
  
  for (int i=0;i<n_address;i++)
    address[i]->Write(buffer);

  // BDAY:1970-06-23T00:00:00Z

  // communication data
  for (int i=0;i<n_commdata;i++)
    commdata[i]->Write(buffer);

  //APPEND(*buffer,"X-KADDRESSBOOK-X-AssistantsName:",assistant);
  //X-KADDRESSBOOK-X-CUSTOM-KPILOT-MODIFIED:0
  //X-KADDRESSBOOK-X-CUSTOM-KPILOT_ID:2216076
  APPEND(*buffer,"X-KADDRESSBOOK-X-Department:",department);
  //APPEND(*buffer,"X-KADDRESSBOOK-X-ManagersName:",manager);
  APPEND(*buffer,"X-KADDRESSBOOK-X-Office:",office_location);
  //APPEND(*buffer,"X-KADDRESSBOOK-X-Profession:",profession);
  APPEND(*buffer,"NOTE:",body);

  /*
    PHOTO;ENCODING=b;TYPE=image/jpeg:<data>

    data encoding ???
    length of line = 76 appended line do have a leading space
  */

  APPEND(*buffer,"","END:VCARD");
}

