#ifndef ICAL_VCARD_
#define ICAL_VCARD_

#include <stdlib.h>

#define Method(N,T) \
  void N(T x); \
  T N();

class vAddress {
  int type;  // PRIVATE=1, WORK=2
  char street[129];       //
  char city[65];          //
  char state[65];         //
  char postal_code[17];   //
  char country[33];       //
  char po_box[17];        //
 public:
  vAddress(char *text=NULL);

  Method(Type,int);
  Method(Street,const char*);
  Method(City,const char*);
  Method(State,const char*);
  Method(ZIP,const char*);
  Method(Country,const char*);

  void Write(char **buffer);
};

class vCommData {
  int type; // 1 = TEL;TYPE=HOME | 3 = TEL;TYPE=CELL | 4 = EMAIL | 5 = URL | 10 = TEL;TYPE=WORK | 11 = TEL;TYPE=FAX
  char value[256];
 public:
  vCommData(char *text=NULL);
  
  Method(Type,int);
  Method(Value,char*);

  void Write(char **buffer);
};

class vCard {
  unsigned long id;
  time_t last_update;
  char suid[512];
  int photo_type;       
  int importance;
  int sensitivity;
  char subject[256];
  char folder[256];
  char anniversary[17];
  char first_name[65];    //
  char middle_name[65];   //
  char last_name[65];     // 
  char display_name[129]; // FN
  char birthday[17];
  char body[4096];        // NOTE
  char categories[256];
  char children[256];
  char hobbies[256];
  char initials[17];
  char languages[256];
  char nickname[65];      // NICKNAME
  char spouse[129];
  char suffix[33];
  char title[33];         // TITLE
  char gender[2];
  char assistant[129];    // X-KADDRESSBOOK-X-AssistantsName
  char company[256];      // ORG
  char department[256];   // X-KADDRESSBOOK-X-Department
  char job_title[256];    // ROLE
  char manager[129];        // X-KADDRESSBOOK-X-ManagersName
  char mileage[17];
  char office_location[65]; // X-KADDRESSBOOK-X-Office
  char profession[65];      // X-KADDRESSBOOK-X-Profession
  char companies[256];
  
  int n_address;
  vAddress **address;
  
  int n_commdata;
  vCommData **commdata;
 public:
  vCard(char *text=NULL);
  ~vCard();
  
  Method(ID,unsigned long);
  Method(LastUpdate,time_t);
  Method(UID,const char*);
  Method(PhotoType,int);
  Method(Importance,int);
  Method(Sensitivity,int);
  Method(Subject,const char*);
  Method(Folder,const char*);
  Method(Firstname,const char*);
  Method(Middlename,const char*);
  Method(Surename,const char*);
  Method(Displayname,const char*);

  Method(Birthday,const char*);
  Method(Anniversary,const char*);
  Method(Note,const char*);
  Method(Category,const char*);
  Method(Children,const char*);
  Method(Hobby,const char*);
  Method(Initials,const char*);
  Method(Language,const char*);
  Method(Nickname,const char*);
  Method(Spouse,const char*);
  Method(Suffix,const char*);
  Method(Title,const char*);
  Method(Gender,const char*);
  Method(Assistant,const char*);
  Method(Company,const char*);
  Method(Department,const char*);
  Method(JobTitle,const char*);
  Method(Manager,const char*);
  Method(Mileage,const char*);
  Method(OfficeLocation,const char*);
  Method(Profession,const char*);
  Method(Companies,const char*);

  void AddAddress(vAddress *p);
  int NAddress();
  vAddress *Address(int i);

  void AddCommData(vCommData *p);
  int NCommData();
  vCommData* CommData(int i);

  void Write(char **buffer);
};

#endif
